#ifndef _LISTS_H_
  #define _LISTS_H_ 1

class slist_base_iter;
class slist_base;

class slink {
  friend class slist_base_iter;
  friend class slist_base;
  slink *next;

public:
  slink() {next = 0;}
  slink(slink *p) {next = p;}
  slink *succ() const {return next;}
  // dunno why this doesn;t work
  // virtual ~slink() {};
};


class slist_base {
  friend class slist_base_iter;

public:
  slist_base() {head = 0;}
  void insert(slink *p) {p->next = head; head = p;}
  void insert(slink *, slist_base_iter &);
  slink *top() const {return head;}
  int empty() const {return (head == 0);}
//  int multiple() const {if (head) return (!head->next == 0); else return 0;}

private:
  slink *head;
};

class slist_base_iter {
  friend class slist_base;
  slink *curr;
  slink *prev;
  slist_base *base;

public:
  slist_base_iter(slist_base &basis)
	 {base = &basis; curr = base->head; prev = 0;}
  slist_base_iter() {base = 0; curr = prev = 0;}
  void Reset(slist_base &basis)
	 {base = &basis; curr = base->head; prev = 0;}
  slink *current() const {return curr;};
  slink *first() {prev = 0; return (curr = base->head);}
  slink *next();
//  slink *operator()();
  void insert(slink *);
  int Valid() {return (base != 0);}

};


template<class T> class Islist_iter;

template<class T> class Islist : slist_base {
  friend class Islist_iter<T>;
public:
  Islist() : slist_base() {};
  void insert(slink *p) {slist_base::insert(p);}
  int empty() {return slist_base::empty();}
//  int multiple() {return slist_base::multiple();}
//  void insert(slink *p, Islist_iter<T> &i)
//	  {slist_base::insert(p,i);}

};

template<class T> class Islist_iter : slist_base_iter {
  friend class Islist<T>;
public:
  Islist_iter(Islist<T> &base) : slist_base_iter(base) {};
  Islist_iter() : slist_base_iter() {};
  void Reset(Islist<T> &base) {slist_base_iter::Reset(base);}
  T *current() {return (T *) slist_base_iter::current();}
  T *first() {return (T *) slist_base_iter::first();}
  T *next() {return (T *) slist_base_iter::next();}
//  T *operator()() {return (T *) slist_base_iter::operator()();}
  void insert(slink *p){slist_base_iter::insert(p);}
  int Valid() {return slist_base_iter::Valid();}
};

#endif
